require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_BITOPS_H)) {
    eval 'sub _SPARC_BITOPS_H () {1;}' unless defined(&_SPARC_BITOPS_H);
    require 'linux/compiler.ph';
    require 'asm/byteorder.ph';
    if(defined(&__KERNEL__)) {
	eval 'sub smp_mb__before_clear_bit () {
	    eval q( &do { }  &while(0));
	}' unless defined(&smp_mb__before_clear_bit);
	eval 'sub smp_mb__after_clear_bit () {
	    eval q( &do { }  &while(0));
	}' unless defined(&smp_mb__after_clear_bit);
	eval 'sub fls {
	    local($x) = @_;
    	    eval q( &generic_fls($x));
	}' unless defined(&fls);
	eval 'sub hweight32 {
	    local($x) = @_;
    	    eval q( &generic_hweight32($x));
	}' unless defined(&hweight32);
	eval 'sub hweight16 {
	    local($x) = @_;
    	    eval q( &generic_hweight16($x));
	}' unless defined(&hweight16);
	eval 'sub hweight8 {
	    local($x) = @_;
    	    eval q( &generic_hweight8($x));
	}' unless defined(&hweight8);
	eval 'sub find_first_zero_bit {
	    local($addr, $size) = @_;
    	    eval q( &find_next_zero_bit(($addr), ($size), 0));
	}' unless defined(&find_first_zero_bit);
	eval 'sub find_first_zero_le_bit {
	    local($addr, $size) = @_;
    	    eval q( &find_next_zero_le_bit(($addr), ($size), 0));
	}' unless defined(&find_first_zero_le_bit);
	eval 'sub ext2_set_bit () { &__test_and_set_le_bit;}' unless defined(&ext2_set_bit);
	eval 'sub ext2_clear_bit () { &__test_and_clear_le_bit;}' unless defined(&ext2_clear_bit);
	eval 'sub ext2_set_bit_atomic {
	    local($lock, $nr, $addr) = @_;
    	    eval q(({ \'int\'  &ret;  &spin_lock($lock);  &ret =  &ext2_set_bit(($nr), ($addr));  &spin_unlock($lock);  &ret; }));
	}' unless defined(&ext2_set_bit_atomic);
	eval 'sub ext2_clear_bit_atomic {
	    local($lock, $nr, $addr) = @_;
    	    eval q(({ \'int\'  &ret;  &spin_lock($lock);  &ret =  &ext2_clear_bit(($nr), ($addr));  &spin_unlock($lock);  &ret; }));
	}' unless defined(&ext2_clear_bit_atomic);
	eval 'sub ext2_test_bit () { &test_le_bit;}' unless defined(&ext2_test_bit);
	eval 'sub ext2_find_first_zero_bit () { &find_first_zero_le_bit;}' unless defined(&ext2_find_first_zero_bit);
	eval 'sub ext2_find_next_zero_bit () { &find_next_zero_le_bit;}' unless defined(&ext2_find_next_zero_bit);
	eval 'sub minix_test_and_set_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_and_set_bit($nr,$addr));
	}' unless defined(&minix_test_and_set_bit);
	eval 'sub minix_set_bit {
	    local($nr,$addr) = @_;
    	    eval q( &set_bit($nr,$addr));
	}' unless defined(&minix_set_bit);
	eval 'sub minix_test_and_clear_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_and_clear_bit($nr,$addr));
	}' unless defined(&minix_test_and_clear_bit);
	eval 'sub minix_test_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_bit($nr,$addr));
	}' unless defined(&minix_test_bit);
	eval 'sub minix_find_first_zero_bit {
	    local($addr,$size) = @_;
    	    eval q( &find_first_zero_bit($addr,$size));
	}' unless defined(&minix_find_first_zero_bit);
    }
}
1;
