require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_UACCESS_H)) {
    eval 'sub _ASM_UACCESS_H () {1;}' unless defined(&_ASM_UACCESS_H);
    if(defined(&__KERNEL__)) {
	require 'linux/compiler.ph';
	require 'linux/sched.ph';
	require 'linux/string.ph';
	require 'linux/errno.ph';
	require 'asm/vac-ops.ph';
	require 'asm/a.out.ph';
    }
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub KERNEL_DS () {(( &mm_segment_t) { 0});}' unless defined(&KERNEL_DS);
	eval 'sub USER_DS () {(( &mm_segment_t) { -1});}' unless defined(&USER_DS);
	eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
	eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
	eval 'sub get_ds () {
	    eval q(( &KERNEL_DS));
	}' unless defined(&get_ds);
	eval 'sub get_fs () {
	    eval q(( ($current->{thread}->{current_ds})));
	}' unless defined(&get_fs);
	eval 'sub set_fs {
	    local($val) = @_;
    	    eval q((( ($current->{thread}->{current_ds})) = ($val)));
	}' unless defined(&set_fs);
	eval 'sub segment_eq {
	    local($a,$b) = @_;
    	    eval q((($a). &seg == ($b). &seg));
	}' unless defined(&segment_eq);
	eval 'sub __user_ok {
	    local($addr,$size) = @_;
    	    eval q((($addr) <  &STACK_TOP));
	}' unless defined(&__user_ok);
	eval 'sub __kernel_ok () {( &segment_eq( &get_fs(),  &KERNEL_DS));}' unless defined(&__kernel_ok);
	eval 'sub __access_ok {
	    local($addr,$size) = @_;
    	    eval q(( &__user_ok(($addr) &  &get_fs(). &seg,($size))));
	}' unless defined(&__access_ok);
	eval 'sub access_ok {
	    local($type,$addr,$size) = @_;
    	    eval q( &__access_ok(($addr),($size)));
	}' unless defined(&access_ok);
	eval 'sub put_user {
	    local($x,$ptr) = @_;
    	    eval q(({ \'unsigned long __pu_addr\' = ($ptr);  &__put_user_check(( &__typeof__(*($ptr)))($x), &__pu_addr,$sizeof{($ptr)}); }));
	}' unless defined(&put_user);
	eval 'sub get_user {
	    local($x,$ptr) = @_;
    	    eval q(({ \'unsigned long __gu_addr\' = ($ptr);  &__get_user_check(($x), &__gu_addr,$sizeof{($ptr)}, &__typeof__(*($ptr))); }));
	}' unless defined(&get_user);
	eval 'sub __put_user {
	    local($x,$ptr) = @_;
    	    eval q( &__put_user_nocheck(( &__typeof__(*($ptr)))($x),($ptr),$sizeof{($ptr)}));
	}' unless defined(&__put_user);
	eval 'sub __get_user {
	    local($x,$ptr) = @_;
    	    eval q( &__get_user_nocheck(($x),($ptr),$sizeof{($ptr)}, &__typeof__(*($ptr))));
	}' unless defined(&__get_user);
	eval 'sub __m {
	    local($x) = @_;
    	    eval q((($x)));
	}' unless defined(&__m);
	eval 'sub __put_user_check {
	    local($x,$addr,$size) = @_;
    	    eval q(({  &register \'int\'  &__pu_ret;  &if ( &__access_ok($addr,$size)) {  &switch ($size) {  &case 1:  &__put_user_asm($x, &b,$addr, &__pu_ret);  &break;  &case 2:  &__put_user_asm($x, &h,$addr, &__pu_ret);  &break;  &case 4:  &__put_user_asm($x,,$addr, &__pu_ret);  &break;  &case 8:  &__put_user_asm($x, &d,$addr, &__pu_ret);  &break;  &default:  &__pu_ret =  &__put_user_bad();  &break; } }  &else {  &__pu_ret = - &EFAULT; }  &__pu_ret; }));
	}' unless defined(&__put_user_check);
	eval 'sub __put_user_check_ret {
	    local($x,$addr,$size,$retval) = @_;
    	    eval q(({  &register \'int\'  &__foo  &__asm__ (\\"l1\\");  &if ( &__access_ok($addr,$size)) {  &switch ($size) {  &case 1:  &__put_user_asm_ret($x, &b,$addr,$retval, &__foo);  &break;  &case 2:  &__put_user_asm_ret($x, &h,$addr,$retval, &__foo);  &break;  &case 4:  &__put_user_asm_ret($x,,$addr,$retval, &__foo);  &break;  &case 8:  &__put_user_asm_ret($x, &d,$addr,$retval, &__foo);  &break;  &default:  &if ( &__put_user_bad())  &return $retval;  &break; } }  &else  &return $retval; }));
	}' unless defined(&__put_user_check_ret);
	eval 'sub __put_user_nocheck {
	    local($x,$addr,$size) = @_;
    	    eval q(({  &register \'int\'  &__pu_ret;  &switch ($size) {  &case 1:  &__put_user_asm($x, &b,$addr, &__pu_ret);  &break;  &case 2:  &__put_user_asm($x, &h,$addr, &__pu_ret);  &break;  &case 4:  &__put_user_asm($x,,$addr, &__pu_ret);  &break;  &case 8:  &__put_user_asm($x, &d,$addr, &__pu_ret);  &break;  &default:  &__pu_ret =  &__put_user_bad();  &break; }  &__pu_ret; }));
	}' unless defined(&__put_user_nocheck);
	eval 'sub __put_user_nocheck_ret {
	    local($x,$addr,$size,$retval) = @_;
    	    eval q(({  &register \'int\'  &__foo  &__asm__ (\\"l1\\");  &switch ($size) {  &case 1:  &__put_user_asm_ret($x, &b,$addr,$retval, &__foo);  &break;  &case 2:  &__put_user_asm_ret($x, &h,$addr,$retval, &__foo);  &break;  &case 4:  &__put_user_asm_ret($x,,$addr,$retval, &__foo);  &break;  &case 8:  &__put_user_asm_ret($x, &d,$addr,$retval, &__foo);  &break;  &default:  &if ( &__put_user_bad())  &return $retval;  &break; } }));
	}' unless defined(&__put_user_nocheck_ret);
	eval 'sub __put_user_asm {
	    local($x,$size,$addr,$ret) = @_;
    	    eval q( &__asm__  &__volatile__( \\"/* Put user asm, inline. */\\\\n\\" \\"1:\\\\t\\" \\"st\\"$size \\" %1, %2\\\\n\\\\t\\" \\"clr	%0\\\\n\\" \\"2:\\\\n\\\\n\\\\t\\" \\".section .fixup,#alloc,#execinstr\\\\n\\\\t\\" \\".align	4\\\\n\\" \\"3:\\\\n\\\\t\\" \\"b	2b\\\\n\\\\t\\" \\" mov	%3, %0\\\\n\\\\t\\" \\".previous\\\\n\\\\n\\\\t\\" \\".section __ex_table,#alloc\\\\n\\\\t\\" \\".align	4\\\\n\\\\t\\" \\".word	1b, 3b\\\\n\\\\t\\" \\".previous\\\\n\\\\n\\\\t\\" : \\"=&r\\" ($ret) : \\"r\\" ($x), \\"m\\" (* &__m($addr)), \\"i\\" (- &EFAULT)));
	}' unless defined(&__put_user_asm);
	eval 'sub __put_user_asm_ret {
	    local($x,$size,$addr,$ret,$foo) = @_;
    	    eval q( &if ( &__builtin_constant_p($ret)  && $ret == - &EFAULT)  &__asm__  &__volatile__( \\"/* Put user asm ret, inline. */\\\\n\\" \\"1:\\\\t\\" \\"st\\"$size \\" %1, %2\\\\n\\\\n\\\\t\\" \\".section __ex_table,#alloc\\\\n\\\\t\\" \\".align	4\\\\n\\\\t\\" \\".word	1b, __ret_efault\\\\n\\\\n\\\\t\\" \\".previous\\\\n\\\\n\\\\t\\" : \\"=r\\" ($foo) : \\"r\\" ($x), \\"m\\" (* &__m($addr)));  &else  &__asm__  &__volatile( \\"/* Put user asm ret, inline. */\\\\n\\" \\"1:\\\\t\\" \\"st\\"$size \\" %1, %2\\\\n\\\\n\\\\t\\" \\".section .fixup,#alloc,#execinstr\\\\n\\\\t\\" \\".align	4\\\\n\\" \\"3:\\\\n\\\\t\\" \\"ret\\\\n\\\\t\\" \\" restore %%g0, %3, %%o0\\\\n\\\\t\\" \\".previous\\\\n\\\\n\\\\t\\" \\".section __ex_table,#alloc\\\\n\\\\t\\" \\".align	4\\\\n\\\\t\\" \\".word	1b, 3b\\\\n\\\\n\\\\t\\" \\".previous\\\\n\\\\n\\\\t\\" : \\"=r\\" ($foo) : \\"r\\" ($x), \\"m\\" (* &__m($addr)), \\"i\\" ($ret)));
	}' unless defined(&__put_user_asm_ret);
	eval 'sub __get_user_check {
	    local($x,$addr,$size,$type) = @_;
    	    eval q(({  &register \'int\'  &__gu_ret;  &register \'unsigned long __gu_val\';  &if ( &__access_ok($addr,$size)) {  &switch {  &case 1:  &__get_user_asm( &__gu_val, &ub,$addr, &__gu_ret);  &break;  &case 2:  &__get_user_asm( &__gu_val, &uh,$addr, &__gu_ret);  &break;  &case 4:  &__get_user_asm( &__gu_val,,$addr, &__gu_ret);  &break;  &case 8:  &__get_user_asm( &__gu_val, &d,$addr, &__gu_ret);  &break;  &default:  &__gu_val = 0;  &__gu_ret =  &__get_user_bad();  &break; } }  &else {  &__gu_val = 0;  &__gu_ret = - &EFAULT; } $x =  &__gu_val;  &__gu_ret; }));
	}' unless defined(&__get_user_check);
	eval 'sub __get_user_check_ret {
	    local($x,$addr,$size,$type,$retval) = @_;
    	    eval q(({  &register  &unsigned long __gu_val __asm__ (\\"l1\\");  &if ( &__access_ok($addr,$size)) {  &switch {  &case 1:  &__get_user_asm_ret( &__gu_val, &ub,$addr,$retval);  &break;  &case 2:  &__get_user_asm_ret( &__gu_val, &uh,$addr,$retval);  &break;  &case 4:  &__get_user_asm_ret( &__gu_val,,$addr,$retval);  &break;  &case 8:  &__get_user_asm_ret( &__gu_val, &d,$addr,$retval);  &break;  &default:  &if ( &__get_user_bad())  &return $retval; } $x =  &__gu_val; }  &else  &return $retval; }));
	}' unless defined(&__get_user_check_ret);
	eval 'sub __get_user_nocheck {
	    local($x,$addr,$size,$type) = @_;
    	    eval q(({  &register \'int\'  &__gu_ret;  &register \'unsigned long __gu_val\';  &switch {  &case 1:  &__get_user_asm( &__gu_val, &ub,$addr, &__gu_ret);  &break;  &case 2:  &__get_user_asm( &__gu_val, &uh,$addr, &__gu_ret);  &break;  &case 4:  &__get_user_asm( &__gu_val,,$addr, &__gu_ret);  &break;  &case 8:  &__get_user_asm( &__gu_val, &d,$addr, &__gu_ret);  &break;  &default:  &__gu_val = 0;  &__gu_ret =  &__get_user_bad();  &break; } $x =  &__gu_val;  &__gu_ret; }));
	}' unless defined(&__get_user_nocheck);
	eval 'sub __get_user_nocheck_ret {
	    local($x,$addr,$size,$type,$retval) = @_;
    	    eval q(({  &register  &unsigned long __gu_val __asm__ (\\"l1\\");  &switch {  &case 1:  &__get_user_asm_ret( &__gu_val, &ub,$addr,$retval);  &break;  &case 2:  &__get_user_asm_ret( &__gu_val, &uh,$addr,$retval);  &break;  &case 4:  &__get_user_asm_ret( &__gu_val,,$addr,$retval);  &break;  &case 8:  &__get_user_asm_ret( &__gu_val, &d,$addr,$retval);  &break;  &default:  &if ( &__get_user_bad())  &return $retval; } $x =  &__gu_val; }));
	}' unless defined(&__get_user_nocheck_ret);
	eval 'sub __get_user_asm {
	    local($x,$size,$addr,$ret) = @_;
    	    eval q( &__asm__  &__volatile__( \\"/* Get user asm, inline. */\\\\n\\" \\"1:\\\\t\\" \\"ld\\"$size \\" %2, %1\\\\n\\\\t\\" \\"clr	%0\\\\n\\" \\"2:\\\\n\\\\n\\\\t\\" \\".section .fixup,#alloc,#execinstr\\\\n\\\\t\\" \\".align	4\\\\n\\" \\"3:\\\\n\\\\t\\" \\"clr	%1\\\\n\\\\t\\" \\"b	2b\\\\n\\\\t\\" \\" mov	%3, %0\\\\n\\\\n\\\\t\\" \\".previous\\\\n\\\\t\\" \\".section __ex_table,#alloc\\\\n\\\\t\\" \\".align	4\\\\n\\\\t\\" \\".word	1b, 3b\\\\n\\\\n\\\\t\\" \\".previous\\\\n\\\\t\\" : \\"=&r\\" ($ret), \\"=&r\\" ($x) : \\"m\\" (* &__m($addr)), \\"i\\" (- &EFAULT)));
	}' unless defined(&__get_user_asm);
	eval 'sub __get_user_asm_ret {
	    local($x,$size,$addr,$retval) = @_;
    	    eval q( &if ( &__builtin_constant_p($retval)  && $retval == - &EFAULT)  &__asm__  &__volatile__( \\"/* Get user asm ret, inline. */\\\\n\\" \\"1:\\\\t\\" \\"ld\\"$size \\" %1, %0\\\\n\\\\n\\\\t\\" \\".section __ex_table,#alloc\\\\n\\\\t\\" \\".align	4\\\\n\\\\t\\" \\".word	1b,__ret_efault\\\\n\\\\n\\\\t\\" \\".previous\\\\n\\\\t\\" : \\"=&r\\" ($x) : \\"m\\" (* &__m($addr)));  &else  &__asm__  &__volatile__( \\"/* Get user asm ret, inline. */\\\\n\\" \\"1:\\\\t\\" \\"ld\\"$size \\" %1, %0\\\\n\\\\n\\\\t\\" \\".section .fixup,#alloc,#execinstr\\\\n\\\\t\\" \\".align	4\\\\n\\" \\"3:\\\\n\\\\t\\" \\"ret\\\\n\\\\t\\" \\" restore %%g0, %2, %%o0\\\\n\\\\n\\\\t\\" \\".previous\\\\n\\\\t\\" \\".section __ex_table,#alloc\\\\n\\\\t\\" \\".align	4\\\\n\\\\t\\" \\".word	1b, 3b\\\\n\\\\n\\\\t\\" \\".previous\\\\n\\\\t\\" : \\"=&r\\" ($x) : \\"m\\" (* &__m($addr)), \\"i\\" ($retval)));
	}' unless defined(&__get_user_asm_ret);
    }
}
1;
