require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_PAGE_H)) {
    eval 'sub _SPARC64_PAGE_H () {1;}' unless defined(&_SPARC64_PAGE_H);
    require 'linux/config.ph';
    eval 'sub PAGE_SHIFT () {13;}' unless defined(&PAGE_SHIFT);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub PAGE_SIZE () {(1 <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    } else {
	eval 'sub PAGE_SIZE () {(1<<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    }
    eval 'sub PAGE_MASK () {(~( &PAGE_SIZE-1));}' unless defined(&PAGE_MASK);
    if(defined(&__KERNEL__)) {
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub WANT_PAGE_VIRTUAL () {1;}' unless defined(&WANT_PAGE_VIRTUAL);
	    eval 'sub clear_page {
	        local($X) = @_;
    		eval q( &_clear_page(($X)));
	    }' unless defined(&clear_page);
	    eval 'sub copy_page {
	        local($X,$Y) = @_;
    		eval q( &__memcpy(, ($Y),  &PAGE_SIZE));
	    }' unless defined(&copy_page);
	    if(defined(&STRICT_MM_TYPECHECKS)) {
		eval 'sub pte_val {
		    local($x) = @_;
    		    eval q((($x). &pte));
		}' unless defined(&pte_val);
		eval 'sub iopte_val {
		    local($x) = @_;
    		    eval q((($x). &iopte));
		}' unless defined(&iopte_val);
		eval 'sub pmd_val {
		    local($x) = @_;
    		    eval q((($x). &pmd));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    local($x) = @_;
    		    eval q((($x). &pgd));
		}' unless defined(&pgd_val);
		eval 'sub ctxd_val {
		    local($x) = @_;
    		    eval q((($x). &ctxd));
		}' unless defined(&ctxd_val);
		eval 'sub pgprot_val {
		    local($x) = @_;
    		    eval q((($x). &pgprot));
		}' unless defined(&pgprot_val);
		eval 'sub iopgprot_val {
		    local($x) = @_;
    		    eval q((($x). &iopgprot));
		}' unless defined(&iopgprot_val);
		eval 'sub __pte {
		    local($x) = @_;
    		    eval q((( &pte_t) { ($x) } ));
		}' unless defined(&__pte);
		eval 'sub __iopte {
		    local($x) = @_;
    		    eval q((( &iopte_t) { ($x) } ));
		}' unless defined(&__iopte);
		eval 'sub __pmd {
		    local($x) = @_;
    		    eval q((( &pmd_t) { ($x) } ));
		}' unless defined(&__pmd);
		eval 'sub __pgd {
		    local($x) = @_;
    		    eval q((( &pgd_t) { ($x) } ));
		}' unless defined(&__pgd);
		eval 'sub __ctxd {
		    local($x) = @_;
    		    eval q((( &ctxd_t) { ($x) } ));
		}' unless defined(&__ctxd);
		eval 'sub __pgprot {
		    local($x) = @_;
    		    eval q((( &pgprot_t) { ($x) } ));
		}' unless defined(&__pgprot);
		eval 'sub __iopgprot {
		    local($x) = @_;
    		    eval q((( &iopgprot_t) { ($x) } ));
		}' unless defined(&__iopgprot);
	    } else {
		eval 'sub pte_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&pte_val);
		eval 'sub iopte_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&iopte_val);
		eval 'sub pmd_val {
		    local($x) = @_;
    		    eval q((($x)));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    local($x) = @_;
    		    eval q((($x)));
		}' unless defined(&pgd_val);
		eval 'sub ctxd_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&ctxd_val);
		eval 'sub pgprot_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgprot_val);
		eval 'sub iopgprot_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&iopgprot_val);
		eval 'sub __pte {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pte);
		eval 'sub __iopte {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__iopte);
		eval 'sub __pmd {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pmd);
		eval 'sub __pgd {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgd);
		eval 'sub __ctxd {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__ctxd);
		eval 'sub __pgprot {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgprot);
		eval 'sub __iopgprot {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__iopgprot);
	    }
	    eval 'sub HPAGE_SHIFT () {22;}' unless defined(&HPAGE_SHIFT);
	    if(defined(&CONFIG_HUGETLB_PAGE)) {
		eval 'sub HPAGE_SIZE () {((1) <<  &HPAGE_SHIFT);}' unless defined(&HPAGE_SIZE);
		eval 'sub HPAGE_MASK () {(~( &HPAGE_SIZE - 1));}' unless defined(&HPAGE_MASK);
		eval 'sub HUGETLB_PAGE_ORDER () {( &HPAGE_SHIFT -  &PAGE_SHIFT);}' unless defined(&HUGETLB_PAGE_ORDER);
	    }
	    eval 'sub TASK_UNMAPPED_BASE () {( &test_thread_flag( &TIF_32BIT) ? (0x70000000) : ( &PAGE_OFFSET));}' unless defined(&TASK_UNMAPPED_BASE);
	}
	eval 'sub PAGE_ALIGN {
	    local($addr) = @_;
    	    eval q(((($addr)+ &PAGE_SIZE-1) &PAGE_MASK));
	}' unless defined(&PAGE_ALIGN);
	eval 'sub PAGE_OFFSET () {1.84467352776165e+19;}' unless defined(&PAGE_OFFSET);
	eval 'sub __pa {
	    local($x) = @_;
    	    eval q((($x) -  &PAGE_OFFSET));
	}' unless defined(&__pa);
	eval 'sub __va {
	    local($x) = @_;
    	    eval q((( ($x) +  &PAGE_OFFSET)));
	}' unless defined(&__va);
	eval 'sub pfn_to_page {
	    local($pfn) = @_;
    	    eval q(( &mem_map + (($pfn)-( &pfn_base))));
	}' unless defined(&pfn_to_page);
	eval 'sub page_to_pfn {
	    local($page) = @_;
    	    eval q((((($page) -  &mem_map) +  &pfn_base)));
	}' unless defined(&page_to_pfn);
	eval 'sub virt_to_page {
	    local($kaddr) = @_;
    	    eval q( &pfn_to_page( &__pa($kaddr)>> &PAGE_SHIFT));
	}' unless defined(&virt_to_page);
	eval 'sub pfn_valid {
	    local($pfn) = @_;
    	    eval q(((($pfn)-( &pfn_base)) <  &max_mapnr));
	}' unless defined(&pfn_valid);
	eval 'sub virt_addr_valid {
	    local($kaddr) = @_;
    	    eval q( &pfn_valid( &__pa($kaddr) >>  &PAGE_SHIFT));
	}' unless defined(&virt_addr_valid);
	eval 'sub virt_to_phys () { &__pa;}' unless defined(&virt_to_phys);
	eval 'sub phys_to_virt () { &__va;}' unless defined(&phys_to_virt);
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub SPARC_PHYS_BANKS () {32;}' unless defined(&SPARC_PHYS_BANKS);
	}
	eval 'sub VM_DATA_DEFAULT_FLAGS () {( &VM_READ |  &VM_WRITE |  &VM_EXEC |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC);}' unless defined(&VM_DATA_DEFAULT_FLAGS);
    }
}
1;
